module Woody::Influx
  extend self

  def influx(measurment, tags: nil, values:)
    send! line(measurment, tags, values)
  end

  private

    def line(measurment, tags, values)
      "#{measurment}#{',' unless tags.nil?}#{fields tags} #{fields values}"
    end

    def send!(data)
      UDPSocket.new.send data, 0, *influx_url
    end

    def fields(value_map)
      value_map.map { |k, v| "#{k}=#{v}" }.join(',') unless value_map.nil?
    end

    def influx_url
      ENV['INFLUX_URL'].split(':')
    end
end
